#include <windows.h>
#include <string>
#include <TCHAR.H>
#include <Psapi.h>
#pragma comment( lib, "Psapi.lib" )
#include "foo.h"

int getHikousekiPath( char *procPath, int procPathLen )
{
    DWORD procList[MAX_PROC_LIST];
    DWORD cbNeeded;
    int nProc;
    int nMatchProc = 0;
    int i;

    // PIDꗗ擾
    if( !EnumProcesses(procList, sizeof(procList), &cbNeeded) ) {
        return -1;
    }

    nProc = cbNeeded / sizeof(DWORD);

    for (i = 0; i < nProc; i++) {
        TCHAR resProcPath[MAX_PATH];
        TCHAR procName[MAX_PATH];

        HANDLE hProcess = OpenProcess(
            PROCESS_QUERY_INFORMATION | PROCESS_VM_READ,
            FALSE, procList[i] );

        // vZX擾
        if (NULL != hProcess) {
            HMODULE hMod;
            DWORD cbNeeded;

            if( EnumProcessModules(hProcess, &hMod, sizeof(hMod), &cbNeeded) ) {
                GetModuleBaseName(hProcess, hMod, procName, 
                  sizeof(procName)/sizeof(TCHAR));
                if( _tcscmp(procName, TEXT("hikouseki.exe")) == 0 ) {
                    GetModuleFileNameEx( hProcess, hMod, resProcPath, sizeof(resProcPath)/sizeof(TCHAR) );
                    _tsetlocale(LC_ALL, _T(""));
                    int outByteSize = WideCharToMultiByte(
                        CP_UTF8, 0,
                        resProcPath, sizeof(resProcPath)/sizeof(TCHAR),
                        NULL, 0, NULL, NULL ); 
                    if( (outByteSize == 0) || (outByteSize > (sizeof(resProcPath) * sizeof(TCHAR))) ) {
                        return -2;
                    }
                    int convByteSize = WideCharToMultiByte(
                        CP_UTF8, 0,
                        resProcPath, sizeof(resProcPath)/sizeof(TCHAR),
                        procPath, outByteSize, NULL, NULL ); 
                    if( outByteSize != convByteSize ) {
                        return -3;
                    }
                    nMatchProc++;
                }
            }
        }
        CloseHandle(hProcess);
    }
    return nMatchProc;
}
